searchNodes=[{"doc":"Mathematical functions and constants.","ref":"Math.html","title":"Math","type":"module"},{"doc":"Equality-test for whether x and y are nearly equal. This is useful when working with floating-point numbers, as these introduce small rounding errors. Examples iex&gt; 2.3 - 0.3 == 2.0 false iex&gt; 2.3 - 0.3 &lt;~&gt; 2.0 true","ref":"Math.html#%3C~%3E/2","title":"Math.<~>/2","type":"function"},{"doc":"Computes the arc cosine of x . (expressed in radians)","ref":"Math.html#acos/1","title":"Math.acos/1","type":"function"},{"doc":"Computes the inverse hyperbolic cosine of x .","ref":"Math.html#acosh/1","title":"Math.acosh/1","type":"function"},{"doc":"Computes the arc sine of x . (expressed in radians)","ref":"Math.html#asin/1","title":"Math.asin/1","type":"function"},{"doc":"Computes the inverse hyperbolic sine of x .","ref":"Math.html#asinh/1","title":"Math.asinh/1","type":"function"},{"doc":"Computes the arc tangent of x . (expressed in radians)","ref":"Math.html#atan/1","title":"Math.atan/1","type":"function"},{"doc":"Computes the arc tangent given y and x . (expressed in radians) This variant returns the inverse tangent in the correct quadrant, as the signs of both x and y are known.","ref":"Math.html#atan2/2","title":"Math.atan2/2","type":"function"},{"doc":"Computes the inverse hyperbolic tangent of x .","ref":"Math.html#atanh/1","title":"Math.atanh/1","type":"function"},{"doc":"Computes the y value of a given t point on a bezier_curve If t is not in range [0,1] returns the interpolated point outside control points bounding box ## Examples iex&gt; Math . bezier_curve ( 0.5 , [ { 0 , 0 } , { 1 , 1 } ] ) { 0.5 , 0.5 }","ref":"Math.html#bezier_curve/2","title":"Math.bezier_curve/2","type":"function"},{"doc":"Computes the y value of a given t point on a bezier_curve Similar to bezier_curve/2 , but raises an error if not on range [0,1]. ## Examples iex&gt; Math . bezier_curve! ( 0.5 , [ { 0 , 0 } , { 1 , 1 } ] ) { 0.5 , 0.5 } iex&gt; Math . bezier_curve! ( 1.5 , [ { 0 , 0 } , { 1 , 1 } ] ) ** (ArgumentError) t is not beetween 0 and 1","ref":"Math.html#bezier_curve!/2","title":"Math.bezier_curve!/2","type":"function"},{"doc":"Computes the cosine of x . x is interpreted as a value in radians.","ref":"Math.html#cos/1","title":"Math.cos/1","type":"function"},{"doc":"Computes the hyperbolic cosine of x (expressed in radians).","ref":"Math.html#cosh/1","title":"Math.cosh/1","type":"function"},{"doc":"Converts degrees to radians Examples iex&gt; Math . deg2rad ( 180 ) 3.141592653589793","ref":"Math.html#deg2rad/1","title":"Math.deg2rad/1","type":"function"},{"doc":"The mathematical constant ℯ (e).","ref":"Math.html#e/0","title":"Math.e/0","type":"function"},{"doc":"Calculates integers gcd , s , and t for as + bt = gcd(a, b) Also see Math.gcd/2 . Returns a tuple: {gcd, s, t} Examples iex&gt; Math . egcd ( 2 , 4 ) { 2 , 1 , 0 } iex&gt; Math . egcd ( 2 , 3 ) { 1 , - 1 , 1 } iex&gt; Math . egcd ( 12 , 8 ) { 4 , 1 , - 1 } iex&gt; Math . egcd ( 54 , 24 ) { 6 , 1 , - 2 } iex&gt; Math . egcd ( - 54 , 24 ) { 6 , 1 , - 2 }","ref":"Math.html#egcd/2","title":"Math.egcd/2","type":"function"},{"doc":"Calculates ℯ to the xth power.","ref":"Math.html#exp/1","title":"Math.exp/1","type":"function"},{"doc":"Calculates the factorial of n : 1 2 3 ... n To make this function faster, values of n up to 1000 are precomputed at compile time. Examples iex&gt; Math . factorial ( 1 ) 1 iex&gt; Math . factorial ( 5 ) 120 iex&gt; Math . factorial ( 20 ) 2432902008176640000","ref":"Math.html#factorial/1","title":"Math.factorial/1","type":"function"},{"doc":"Calculates the Greatest Common divisor of two numbers. This is the largest positive integer that divides both a and b without leaving a remainder. Also see Math.lcm/2 Examples iex&gt; Math . gcd ( 2 , 4 ) 2 iex&gt; Math . gcd ( 2 , 3 ) 1 iex&gt; Math . gcd ( 12 , 8 ) 4 iex&gt; Math . gcd ( 54 , 24 ) 6 iex&gt; Math . gcd ( - 54 , 24 ) 6","ref":"Math.html#gcd/2","title":"Math.gcd/2","type":"function"},{"doc":"Calculates the non-negative integer square root of x (rounded towards zero) Does not accept negative numbers as input. Examples iex&gt; Math . isqrt ( 100 ) 10 iex&gt; Math . isqrt ( 16 ) 4 iex&gt; Math . isqrt ( 65536 ) 256 iex&gt; Math . isqrt ( 10 ) 3","ref":"Math.html#isqrt/1","title":"Math.isqrt/1","type":"function"},{"doc":"Calculates the k-combinations of n . Examples iex&gt; Math . k_combinations ( 10 , 2 ) 45 iex&gt; Math . k_combinations ( 5 , 5 ) 1 iex&gt; Math . k_combinations ( 3 , 4 ) 0","ref":"Math.html#k_combinations/2","title":"Math.k_combinations/2","type":"function"},{"doc":"Calculates the k-permutations of n . This is the number of distinct ways to create groups of size k from n distinct elements. Notice that n is the first parameter, for easier piping. Examples iex&gt; Math . k_permutations ( 10 , 2 ) 90 iex&gt; Math . k_permutations ( 5 , 5 ) 120 iex&gt; Math . k_permutations ( 3 , 4 ) 0","ref":"Math.html#k_permutations/2","title":"Math.k_permutations/2","type":"function"},{"doc":"Calculates the Least Common Multiple of two numbers. This is the smallest positive integer that can be divided by both a by b without leaving a remainder. Also see Math.gcd/2 Examples iex&gt; Math . lcm ( 4 , 6 ) 12 iex&gt; Math . lcm ( 3 , 7 ) 21 iex&gt; Math . lcm ( 21 , 6 ) 42","ref":"Math.html#lcm/2","title":"Math.lcm/2","type":"function"},{"doc":"Computes the y value of a given t point on a linear_interpolation between 2 points If t is not in range [0,1] returns the interpolated point outside control points bounding box Examples iex&gt; Math . linear_interpolation ( 0.5 , { 0 , 0 } , { 1 , 1 } ) { 0.5 , 0.5 }","ref":"Math.html#linear_interpolation/3","title":"Math.linear_interpolation/3","type":"function"},{"doc":"Computes the point of a given t on a linear_interpolation between 2 points Similar to linear_interpolation/3 , but raises an error if not on range [0,1]. Examples iex&gt; Math . linear_interpolation! ( 0.5 , { 0 , 0 } , { 1 , 1 } ) { 0.5 , 0.5 } iex&gt; Math . linear_interpolation! ( 1.5 , { 0 , 0 } , { 1 , 1 } ) ** (ArgumentError) t is not beetween 0 and 1","ref":"Math.html#linear_interpolation!/3","title":"Math.linear_interpolation!/3","type":"function"},{"doc":"Calculates the natural logarithm (base ℯ ) of x . See also Math.e/0 .","ref":"Math.html#log/1","title":"Math.log/1","type":"function"},{"doc":"Calculates the base- b logarithm of x Note that variants for the most common logarithms exist that are faster and more precise. See also Math.log/1 , Math.log2/1 and Math.log10/1 . Examples iex&gt; Math . log ( 5 , 5 ) 1.0 iex&gt; Math . log ( 20 , 2 ) &lt;~&gt; Math . log2 ( 20 ) true iex&gt; Math . log ( 20 , 10 ) &lt;~&gt; Math . log10 ( 20 ) true iex&gt; Math . log ( 2 , 4 ) 0.5 iex&gt; Math . log ( 10 , 4 ) 1.6609640474436813","ref":"Math.html#log/2","title":"Math.log/2","type":"function"},{"doc":"Calculates the common logarithm (base 10 ) of x . See also Math.log/2 .","ref":"Math.html#log10/1","title":"Math.log10/1","type":"function"},{"doc":"Calculates the binary logarithm (base 2 ) of x . See also Math.log/2 .","ref":"Math.html#log2/1","title":"Math.log2/1","type":"function"},{"doc":"Computes the modular multiplicatibe inverse of a under modulo m In other words, given integers a and m calculate a value b for ab = 1 (mod m) Returns an {:ok, b} tuple or {:error, :not_coprime} when b cannot be calculated for the inputs. Examples iex&gt; Math . mod_inv 3 , 11 { :ok , 4 } iex&gt; Math . mod_inv 10 , 17 { :ok , 12 } iex&gt; Math . mod_inv 123 , 455 { :ok , 37 } iex&gt; Math . mod_inv 123 , 456 { :error , :not_coprime }","ref":"Math.html#mod_inv/2","title":"Math.mod_inv/2","type":"function"},{"doc":"Computes the modular multiplicatibe inverse of a under modulo m Similar to mod_in/2 , but returns only the value or raises an error. Examples iex&gt; Math . mod_inv! 3 , 11 4 iex&gt; Math . mod_inv! 10 , 17 12 iex&gt; Math . mod_inv! 123 , 455 37 iex&gt; Math . mod_inv! 123 , 456 ** (ArithmeticError) Inputs are not coprime!","ref":"Math.html#mod_inv!/2","title":"Math.mod_inv!/2","type":"function"},{"doc":"Calculates the non-negative nth-root of x . Examples iex&gt; Math . nth_root ( 27 , 3 ) 3.0 iex&gt; Math . nth_root ( 65536 , 8 ) 4.0","ref":"Math.html#nth_root/2","title":"Math.nth_root/2","type":"function"},{"doc":"The mathematical constant π (pi). The ratio of a circle's circumference to its diameter. The returned number is a floating-point approximation (as π is irrational)","ref":"Math.html#pi/0","title":"Math.pi/0","type":"function"},{"doc":"Arithmetic exponentiation. Calculates x to the n -th power. When both x and n are integers and n is positive, returns an integer . When n is a negative integer, returns a float . When working with integers, the Exponentiation by Squaring algorithm is used, to allow for a fast and precise result. When one of the numbers is a float, returns a float by using erlang's :math.pow/2 function. It is possible to calculate roots by choosing n between 0.0 and 1.0 (To calculate the p -th-root, pass 1/ p to the function) Examples iex&gt; Math . pow ( 2 , 4 ) 16 iex&gt; Math . pow ( 2.0 , 4 ) 16.0 iex&gt; Math . pow ( 2 , 4.0 ) 16.0 iex&gt; Math . pow ( 5 , 100 ) 7888609052210118054117285652827862296732064351090230047702789306640625 iex&gt; Math . pow ( 5.0 , 100 ) 7.888609052210118e69 iex&gt; Math . pow ( 2 , ( 1 / 2 ) ) 1.4142135623730951","ref":"Math.html#pow/2","title":"Math.pow/2","type":"function"},{"doc":"Converts radians to degrees Examples iex&gt; Math . rad2deg ( Math . pi ) 180.0","ref":"Math.html#rad2deg/1","title":"Math.rad2deg/1","type":"function"},{"doc":"Computes the sine of x . x is interpreted as a value in radians.","ref":"Math.html#sin/1","title":"Math.sin/1","type":"function"},{"doc":"Computes the hyperbolic sine of x (expressed in radians).","ref":"Math.html#sinh/1","title":"Math.sinh/1","type":"function"},{"doc":"Calculates the non-negative square root of x .","ref":"Math.html#sqrt/1","title":"Math.sqrt/1","type":"function"},{"doc":"Computes the tangent of x (expressed in radians).","ref":"Math.html#tan/1","title":"Math.tan/1","type":"function"},{"doc":"Computes the hyperbolic tangent of x (expressed in radians).","ref":"Math.html#tanh/1","title":"Math.tanh/1","type":"function"},{"doc":"The mathematical constant τ (tau). The ratio of a circle's circumference to its radius. Defined as 2 * π, but preferred by some mathematicians. The returned number is a floating-point approximation (as τ is irrational)","ref":"Math.html#tau/0","title":"Math.tau/0","type":"function"},{"doc":"","ref":"Math.html#t:x/0","title":"Math.x/0","type":"type"},{"doc":"","ref":"Math.html#t:y/0","title":"Math.y/0","type":"type"},{"doc":"Math.Enum defines Math-functions that work on any collection extending the Enumerable protocol. This means Maps, Lists, Sets, etc., and any custom collection types as well.","ref":"Math.Enum.html","title":"Math.Enum","type":"module"},{"doc":"Calculates the mean of a collection of numbers. This is the sum, divided by the amount of elements in the collection. If the collection is empty, returns nil Also see Math.Enum.median/1 Examples iex&gt; Math.Enum . mean [ 1 , 2 , 3 ] 2.0 iex&gt; Math.Enum . mean 1 .. 10 5.5 iex&gt; Math.Enum . mean [ 1 , 2 , 3 , 4 , 5 , - 100 ] - 14.166666666666666 iex&gt; Math.Enum . mean [ ] nil","ref":"Math.Enum.html#mean/1","title":"Math.Enum.mean/1","type":"function"},{"doc":"Calculates the median of a given collection of numbers. If the collection has an odd number of elements, this will be the middle-most element of the (sorted) collection. If the collection has an even number of elements, this will be mean of the middle-most two elements of the (sorted) collection. If the collection is empty, returns nil Also see Math.Enum.mean/1 Examples iex&gt; Math.Enum . median [ 1 , 2 , 3 ] 2 iex&gt; Math.Enum . median 1 .. 10 5.5 iex&gt; Math.Enum . median [ 1 , 2 , 3 , 4 , 5 , - 100 ] 2.5 iex&gt; Math.Enum . median [ 1 , 2 ] 1.5 iex&gt; Math.Enum . median [ ] nil","ref":"Math.Enum.html#median/1","title":"Math.Enum.median/1","type":"function"},{"doc":"Calculates the mode of a given collection of numbers. Always returns a list. An empty input results in an empty list. Supports bimodal/multimodal collections by returning a list with multiple values. Examples iex&gt; Math.Enum . mode [ 1 , 2 , 3 , 4 , 1 ] [ 1 ] iex&gt; Math.Enum . mode [ 1 , 2 , 3 , 2 , 3 ] [ 2 , 3 ] iex&gt; Math.Enum . mode [ ] [ ]","ref":"Math.Enum.html#mode/1","title":"Math.Enum.mode/1","type":"function"},{"doc":"Calculates the product, obtained by multiplying all elements in collection with eachother. Examples iex&gt; Math.Enum . product [ 1 , 2 , 3 ] 6 iex&gt; Math.Enum . product 1 .. 10 3628800 iex&gt; Math.Enum . product [ 1 , 2 , 3 , 4 , 5 , - 100 ] - 12000","ref":"Math.Enum.html#product/1","title":"Math.Enum.product/1","type":"function"},{"doc":"Calculates the standard deviation of a given collection of numbers. If the collection is empty, returns nil Examples iex&gt; Math.Enum . stdev ( [ 1 , 2 , 3 , 4 , 5 ] ) 1.4142135623730951 iex&gt; Math.Enum . stdev 1 .. 10 2.8722813232690143 iex&gt; Math.Enum . stdev [ 1 , 2 , 3 , 4 , 5 , - 100 ] 38.407536876098796 iex&gt; Math.Enum . stdev [ ] nil","ref":"Math.Enum.html#stdev/1","title":"Math.Enum.stdev/1","type":"function"},{"doc":"Calculates the variance of a given collection of numbers. If the collection is empty, returns nil Examples iex&gt; Math.Enum . variance [ 1 , 2 , 3 , 4 , 5 ] 2.0 iex&gt; Math.Enum . variance 1 .. 10 8.25 iex&gt; Math.Enum . variance [ 1 , 2 , 3 , 4 , 5 , - 100 ] 1475.138888888889 iex&gt; Math.Enum . variance [ ] nil","ref":"Math.Enum.html#variance/1","title":"Math.Enum.variance/1","type":"function"},{"doc":"Math The Math module adds many useful functions that extend Elixir's standard library. General Functions a &lt;~&gt; b Comparison of floats, to check if they are effectively equal (if their absolute difference is less than @epsilon ). Math.pow(x, n) Arithmetic exponentiation. Works both with integer powers and floats. Math.sqrt(x) The square root of x . Math.nth_root(x, n) The n-th root of x . Math.isqrt(x) The integer square root of x . Math.gcd(a, b) The greatest common divisor of a and b . Math.egcd(a, b) Calculates integers gcd , s , and t in as + bt = gcd(a,b) . See also Math.gcd(a, b) Math.lcm(a, b) The least common multiple of a and b . Math.factorial(n) The n -th factorial number. Math.k_permutations(n, k) The number of distinct ways to create groups of size k from n distinct elements. Math.k_combinations(n, k) The number of distinct ways to create groups of size k from n distinct elements where order does not matter. Math.mod_inv(a, m) An integer b that fufills ab = 1 (mod m) . Returns an ok/error tuple. Math.mod_inv!(a, m) See Math.mod_inv(a, m) , but returns the value or raises an error. Logarithms Math.exp(x) Calculates ℯ to the xth power. Math.log(x) Calculates the natural logarithm (base ℯ ) of x . Math.log(x, b) Calculates the base- b logarithm of x Math.log2(x) Calculates the binary logarithm (base 2 ) of x . Math.log10(x) Calculates the common logarithm (base 10 ) of x . Math.e Returns a floating-point approximation of the number ℯ. Trigonometry Math.pi Returns a floating-point approximation of the number π . Math.deg2rad(x) converts from degrees to radians. Math.rad2deg(x) converts from radians to degrees. Math.sin(x) The sine of x . Math.cos(x) The cosine of x . Math.tan(x) The tangent of x . Math.asin(x) The inverse sine of x . Math.acos(x) The inverse cosine of x . Math.atan(x) The inverse tangent of x . Math.atan2(x, y) The inverse tangent of x and y . This variant returns the inverse tangent in the correct quadrant, as the signs of both x and y are known. Math.sinh(x) The hyperbolic sine of x . Math.cosh(x) The hyperbolic cosine of x . Math.tanh(x) The hyperbolic tangent of x . Math.asinh(x) The inverse hyperbolic sine of x . Math.acosh(x) The inverse hyperbolic cosine of x . Math.atanh(x) The inverse hyperbolic tangent of x . Interpolation Math.linear_interpolation(t,p0,p1) Returns {x,y} of t in a linear interpolation Math.bezier_curve(t,[p0,p1 ...]) Returns {x,y} of t in a bezier_curve Working with Collections Math.Enum.product(collection) The result of multiplying all elements in the passed collection. Math.Enum.mean(collection) the mean of the numbers in the collection. Math.Enum.median(collection) the median of the numbers in the collection. Math.Enum.mode(collection) the mode of the numbers in the collection. Math.Enum.variance(collection) variance of the numbers in the collection. Math.Enum.stdev(collection) the standard deviation of the numbers in the collection.","ref":"readme.html","title":"Math","type":"extras"},{"doc":"Math is available in Hex . The package can be installed by: Add math to your list of dependencies in mix.exs : def deps do [ {:math, &quot;~&gt; 0.6.0&quot;} ] end Require or import the Math library anywhere in your code you'd like: require Math # or import Math (Importing allows usage of the &lt;~&gt; operator)","ref":"readme.html#installation","title":"Math - Installation","type":"extras"},{"doc":"0.7.0 adds Math.linear_interpolation/3 and Math.bezier_curve/2 . Thank you, @pcarvsilva ! 0.6.0 Adds Math.Enum.variance/1 and Math.Enum.stdev/1 . Thank you, @TenTakano ! 0.5.0 Adds Math.mod_inv , Math.mod_inv! and Math.egcd 0.4.0 Adds Math.Enum.mode/1 . 0.3.1 Updates formatting to hide warnings in newer versions of Elixir. 0.3.0 Fixed incorrect median for lists with even number of items. Updated tests. 0.2.0 Added factorial/1 , nth_sqrt/2 , k_permutations/2 , k_combinations/2 , gcd/2 , lcm/2 and Math.Enum functions. Improved documentation. 0.1.0 Added integer variant of pow/1 , isqrt/2 , deg2rad/1 , rad2deg/1 . Improved documentation. 0.0.1 First implementation, mostly a wrapper around Erlang's :math library.","ref":"readme.html#changelog","title":"Math - Changelog","type":"extras"}]